#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const int MAX=1e5+3;
int n, q;
int a[MAX], cnt[32];
int b[MAX];

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    cin >> n;
    for(int i=0;i<n;++i){
        cin >> a[i];
        int pt=0, v=a[i];
        while(v){
            if(v%2) cnt[pt]++;
            pt++;
            v/=2;
        }
    }
    //for(int i=0;i<31;++i) cout << cnt[i] << ' ';
    //cout << '\n';
    cin >> q;
    while(q--){
        int t; cin >> t;
        if(t==0){
            int k; cin >> k;
            int res=0;
            for(int i=0;i<31;++i){
                if(cnt[i]>=k) res+=(1<<i);
            }
            //for(int i=0;i<31;++i) cout << cnt[i] << ' ';
            //cout << '\n';
            cout << res << '\n';
        }
        else{
            int k, v; cin >> k >> v; k--;
            int pt=0;
            while(a[k]){
                if(a[k]%2) cnt[pt]--;
                pt++;
                a[k]/=2;
            }
            a[k]=v;
            pt=0;
            while(v){
                if(v%2) cnt[pt]++;
                pt++;
                v/=2;
            }
        }
    }

    return 0;
}